load AE1;
plot(AE1);
xlabel('time');
ylabel('AE signals');
title('Original AE signals  Case 1 - Run 1');


xAE = AE1;

% Wavelet de-noising parameters
level = 3;
wname = 'coif3';
tptr  = 'heursure';
sorh  = 's';
scal  = 'mln';


% Set the PCA parameters to select the number of retained principal
% components automatically by 
% Kaiser's rule. Kaiser's rule keeps the PCA components associated with
% eigenvalues greater than the mean of all eigenvalues.
npc_app = 'kais';
npc_fin = 'kais';


% Multivariate wavelet de-noising using Principal Component Analysis (PCA) on approximations in the wavelet domain and for final PCA after wavelet reconstruction.
[x_denAE, npc, nestco] = wmulden(xAE, level, wname, npc_app, npc_fin, tptr, sorh);
figure;
plot(x_denAE);
xlabel('time');
ylabel('Wavelet PCA De-noised AE signals');
title('Multivariate PCA wavelet de-noising  Case 1 - Run 1');


% Extracting de-noised AE vectors.
de_noised_AE_table1 = x_denAE(1:9000,1);
de_noised_AE_spindle1 = x_denAE(1:9000,2);


% Power spectrum estimation using periodogram is computed, then inverse FFT of
% log of periodogram returns power cepstrum.
Fs = 1000;
[Pxx1,f] = periodogram(de_noised_AE_table1,[],'twosided',[],Fs);
Pxx1 = log(Pxx1);
power_cepstrum1 = ifft(Pxx1);
figure;
plot(power_cepstrum1);
xlabel('Quefrency (ms)');
ylabel('Power cepstrum magnitude-gamnitude (dB)');
title('Power Cepstrum of de-noised AE signal of table  Case 1 - Run 1');

Fs = 1000;
[Pxx2,f] = periodogram(de_noised_AE_spindle1,[],'twosided',[],Fs);
Pxx2 = log(Pxx2);
power_cepstrum2 = ifft(Pxx2);
figure;
plot(power_cepstrum2);
xlabel('Quefrency (ms)');
ylabel('Power cepstrum magnitude-gamnitude (dB)');
title('Power Cepstrum of de-noised AE signal of spindle  Case 1 - Run 1');
















